%define ALD_Ver		1.2.1

%define OrgName gcc

License:      GPL/LGPL
Summary:      The GNU c,c++ Compiler
Group:        Development/Tools
Version:      4.4.7
Release:      3

Source: %{OrgName}-core-%{version}.tar.xz
Source2: %{OrgName}-g++-%{version}.tar.xz
#Source3: gcc-objc-%{version}.tar.bz2
Patch0: %{OrgName}-%{version}-gnu89-inline.patch
Patch1: %{OrgName}-%{version}.cross-g.patch
Patch2: %{OrgName}-%{version}.g.patch
Patch3: %{OrgName}-%{version}.pch-g.patch
Patch4: %{OrgName}-%{version}.startfile.patch
Patch5: %{OrgName}-%{version}.NoHostPath.patch

%define DestDir		/Compiler/gcc/%{version}

# -----------------------------------------------------
%if %{_target_cpu} == %{_build_cpu}
%define _CROSS 0
%define BUILD_LOCAL_CROSS 0
%else
# rpm --target=x86_64 -ba xxxxx.spec
%define _CROSS 1
%define BUILD_LOCAL_CROSS 1
%endif

%define TO_ARCH %{_target_cpu}

%if %{_target_cpu} == "armv6l"
%define ARM_ARCH armv6j
%define ARM_FPU  -mfpu=vfp -mfloat-abi=softfp
%define with_float	softfp
%define with_fpu	vfp
%define TO_ARCH %{ARM_ARCH}
%endif

%if %{_target_cpu} == "armv7l"
%define ARM_ARCH armv7-a
%define ARM_FPU  -mfpu=vfpv3-d16 -mfloat-abi=softfp
%define with_float	softfp
%define with_fpu	vfpv3-d16
%define TO_ARCH %{ARM_ARCH}
%endif

%define BUILD_TAR 1
# -----------------------------------------------------
%if %{BUILD_LOCAL_CROSS}
Name:         %{OrgName}-%{TO_ARCH}
%else
Name:         %{OrgName}
%endif

#------------------ CROSS DIR --------------------
%if %{_CROSS}

%if %{_os} == "mingw"
%define target %{_arch}-%{_vendor}-%{_os}%{__isa_bits}
%else  #win32 || win64
%define target %{_arch}-%{_os}%{_gnu}
%endif

%define crossdir	/cross
%if %{_arch} == "arm"
ERROR: use gcc-4.7.3
%define csysdir		%{crossdir}/%{ARM_ARCH}
%else
%define csysdir		%{crossdir}/%{_target_cpu}
%endif
%define csysbindir	%{csysdir}/bin

%if %{BUILD_LOCAL_CROSS}
%define _prefix		%{csysdir}/usr
%define _bindir		%{csysdir}/bin
%define CrossDestDir	/Cross
%if (%{_build_cpu} == "x86_64")
%define _blib		lib64
%else
%define _blib		lib
%endif
%define MathSrcDir	/usr
#define MathSrcDir	/cross/i386-gcc-build
%define __os_install_post \
    %{_rpmconfigdir}/brp-strip \
    %{csysbindir}/rpm/brp-strip-static-archive \
    %{csysbindir}/rpm/brp-strip-shared \
    %{csysbindir}/rpm/brp-strip-comment-note \
    %{_rpmconfigdir}/brp-compress \
%{nil}
%else  #BUILD_LOCAL_CROSS
%define CrossDestDir	%{nil}
%define _blib		%{_lib}
%define MathSrcDir	%{csysdir}/usr
%define __os_install_post \
    %{csysbindir}/rpm/brp-strip \
    %{csysbindir}/rpm/brp-strip-static-archive \
    %{csysbindir}/rpm/brp-strip-shared \
    %{csysbindir}/rpm/brp-strip-comment-note \
    %{_rpmconfigdir}/brp-compress \
%{nil}
%endif #!BUILD_LOCAL_CROSS

%define _srcrpmdir %{_topdir}/SRPMS/tmp

%else  #_CROSS

%define csysdir		%{nil}
%define csysbindir	%{_prefix}/bin
%define CrossDestDir	%{nil}
%define _blib		%{_lib}
%define MathSrcDir	/usr
%define _srcrpmdir	%{_topdir}/SRPMS/%{ALD_Ver}

%define target %{_build}

%endif # !_CROSS

%define docdir %{_defaultdocdir}/%{OrgName}
%define _gccdir %{_libdir}/gcc/%{target}/%{version}

# ------------------- description ------------------------------------
%description
This package contains the GNU Compiler Collection (GCC).
#-------------------------------
%package info
Summary:      Info for %{OrgName}
Group:        Documentation
%description info
Info for %{OrgName}
#-------------------------------
%package c++
Summary:      C++ support for GCC
Group:        Development/Languages
Requires: gcc = %{version}
Requires: gcc-libstdc++ = %{version}
%description c++
This package adds C++ support to the GNU Compiler Collection.
#-------------------------------
%package libgcc
Summary:      GCC shared support library
Group:        System Environment/Libraries
%description libgcc
These libraries are needed to run programms
#-------------------------------
%package libstdc++
Summary:      GNU Standard C++ Library
Group:        System Environment/Libraries
%description libstdc++
These libraries are needed to run programms
#-------------------------------
%package libstdc++-static
Summary:      Static libraries for the GNU standard C++ library
Group:        Development/Libraries
%description libstdc++-static
Static libraries for C++
#-------------------------------
%package libmudflap
Summary:      The libmudflap runtime
Group:        System Environment/Libraries
%description libmudflap
These libraries are needed to run programms
#-------------------------------
%package libmudflap-static
Summary:      Static libraries
Group:        Development/Libraries
%description libmudflap-static
Static libraries for libquadmath

# ------------------- setup ------------------------------------------
%Prep
%setup -q -b2 -n %{OrgName}-%{version}
%if %{BUILD_LOCAL_CROSS}
%patch1 -b .orig -p0
%else
%patch2 -b .orig -p0
%endif
%patch3 -b .orig -p0

%if %{BUILD_LOCAL_CROSS}
%patch4 -b .orig -p0
sed -i s:"@CROSS@":"%{target}": gcc/gcc.c
sed -i s:"MD_STARTFILE_PREFIX \"\"":"MD_STARTFILE_PREFIX \"%{csysdir}/%{_lib}/\"": gcc/gcc.c
sed -i s:"MD_STARTFILE_PREFIX_1 \"\"":"MD_STARTFILE_PREFIX_1 \"%{csysdir}/usr/%{_lib}/\"": gcc/gcc.c
sed -i s:"undef NATIVE_SYSTEM_HEADER_DIR":"undef NATIVE_SYSTEM_HEADER_DIR\n# define NATIVE_SYSTEM_HEADER_DIR \"%{csysdir}%{_includedir}\"": gcc/cppdefault.c
sed -i s:"\"/lib/\"":"\"%{csysdir}/%{_lib}/\"": gcc/gcc.c
sed -i s:"\"/usr/lib/\"":"\"%{csysdir}/usr/%{_lib}/\"": gcc/gcc.c
%patch5 -b .orig2 -p0

%else  #BUILD_LOCAL_CROSS
%if %{_lib} != "lib"
sed -i s:"\"/lib/\"":"\"/%{_lib}/\"": gcc/gcc.c
sed -i s:"\"/usr/lib/\"":"\"/usr/%{_lib}/\"": gcc/gcc.c
%endif
%endif #!BUILD_LOCAL_CROSS

mkdir -p math/include
mkdir -p math/lib
cp %{MathSrcDir}/include/gmp.h math/include
cp %{MathSrcDir}/include/mpf2mpfr.h math/include
cp %{MathSrcDir}/include/mpfr.h math/include
#cp %{MathSrcDir}/include/mpc.h math/include
cp %{MathSrcDir}/%{_blib}/libgmp.a math/lib
cp %{MathSrcDir}/%{_blib}/libmpfr.a math/lib
#cp %{MathSrcDir}/%{_blib}/libmpc.a math/lib

sed -i s:"\${SYSTEM_HEADER_DIR}":"%{csysdir}/usr/include": gcc/Makefile.in

# ------------------- Build ------------------------------------------
%Build
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

%if %{BUILD_LOCAL_CROSS}
%if %{_build_cpu} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer -fno-stack-protector"
%endif
%if %{_build_cpu} == "x86_64"
OPTFLAGS="-O2 -fno-asynchronous-unwind-tables"
%endif
%if (%{_build_cpu} == "armv6l") || (%{_build_cpu} == "armv7l")
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%else
%if %{_arch} == "i386"
OPTFLAGS="-O2 -march=i486 -mpreferred-stack-boundary=2 -falign-functions=1 -falign-jumps=1 -falign-loops=1 -fomit-frame-pointer"
%endif
%if %{_arch} == "x86_64"
OPTFLAGS="-O2 -fno-asynchronous-unwind-tables"
%endif
%if %{_arch} == "arm"
OPTFLAGS="-O2 -march=%{ARM_ARCH} %{ARM_FPU} -munaligned-access"
%endif
%endif

%if %{_os} == "mingw"
CFLAGS="$OPTFLAGS"
CXXFLAGS="$OPTFLAGS"
LDFLAGS=" "
%else
CFLAGS="$OPTFLAGS -ffunction-sections -fdata-sections"
CXXFLAGS="$OPTFLAGS"
LDFLAGS="-Wl,--gc-sections"
%endif

export CFLAGS CXXFLAGS LDFLAGS

export with_gxx_include_dir="%{_gccdir}/c++"

# ---- static gmp + mpfr ---------------
with_gmp=`pwd`/math
with_mpfr=`pwd`/math
export with_gmp with_mpfr

rm -rf zz
mkdir zz
cd zz
../configure \
	--build=%{_build} \
%if %{_CROSS}
%if %{BUILD_LOCAL_CROSS}
	--host=%{_build} \
	--target=%{target} \
%else
	--host=%{target} \
	--target=%{target} \
%endif
%endif
	--prefix=%{_prefix} \
	--bindir=%{_bindir} \
	--libdir=%{_libdir} \
	--libexecdir=%{_libdir} \
%if %{_arch} == "arm"
	--with-arch=%{ARM_ARCH} \
	--with-float=%{with_float} \
	--with-fpu=%{with_fpu} \
%else
%if %{_arch} == "x86_64"
	--with-tune=nocona \
%else
	--with-tune=i486 \
%endif
%endif
	--enable-languages=c,c++ \
%if %{_os} == "mingw"
	--enable-threads=win32 \
	--disable-libmudflap \
	--disable-libquadmath \
%else
	--enable-shared \
	--enable-threads=posix \
%endif
	--disable-multilib \
	--disable-nls \
	--disable-debug \
	--enable-checking=release \
	--enable-c99 \
	--enable-long-long \
	--with-system-zlib \
	--disable-lto \
	--disable-libgomp \
	--disable-libssp \
	--enable-target-optspace \
	--disable-bootstrap \
	--without-ppl \
	&>Fconfigure_log.txt

make -j 2 &>FMake_log.txt
#make &>FMake_log.txt
cd ..

# ------------------- Install ----------------------------------------
%Install
%if %{_CROSS}
PATH=%{csysbindir}:$PATH:/opt/perl/bin
GCC_NoHostPath=d
export PATH GCC_NoHostPath
%else
export PATH=$PATH:/opt/perl/bin
%endif

rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT
mkdir -p %{_srcrpmdir}
mkdir -p $RPM_BUILD_ROOT%{docdir}

cd zz
make DESTDIR=$RPM_BUILD_ROOT install &>FInstall_log.txt
cd ..

rm $RPM_BUILD_ROOT%{_infodir}/dir
rm -r $RPM_BUILD_ROOT%{_includedir}
rm $RPM_BUILD_ROOT%{_libdir}/*.la
rm $RPM_BUILD_ROOT%{_libdir}/libiberty.a
%if %{BUILD_LOCAL_CROSS}
rm -r $RPM_BUILD_ROOT%{_mandir}
%endif

cp COPYING COPYING.LIB COPYING.RUNTIME COPYING3 COPYING3.LIB MAINTAINERS README $RPM_BUILD_ROOT%{docdir}/

%if %{_os} != "mingw"
pushd $RPM_BUILD_ROOT%{_libdir}
  chmod 0755 libgcc_s.so.1
  mv libgcc_s.so.1 libgcc_s-%{version}.so.1
  ln -s libgcc_s-%{version}.so.1 libgcc_s.so.1
  rm libgcc_s.so
  rm libmudflap.so
  rm libmudflapth.so
  rm libstdc++.so
popd

pushd $RPM_BUILD_ROOT%{_gccdir}
  ln -s ../../../libgcc_s.so.1 libgcc_s.so
  ln -s ../../../libmudflap.so.0.* libmudflap.so
  ln -s ../../../libmudflapth.so.0.* libmudflapth.so
  ln -s ../../../libstdc++.so.6.0.* libstdc++.so
popd
%endif #!mingw

%if (%{_os} != "mingw") || %{BUILD_LOCAL_CROSS}
pushd $RPM_BUILD_ROOT%{_bindir}
%if %{BUILD_LOCAL_CROSS}
rm %{target}-c++
ln -s %{target}-g++ %{target}-c++
rm %{target}-gcc-%{version}
ln -s %{target}-gcc %{target}-gcc-%{version}
rm %{target}-gccbug
%else
rm c++
ln -s g++ c++
rm %{target}-c++
rm %{target}-g++
ln -s g++ %{target}-c++
ln -s g++ %{target}-g++
rm %{target}-gcc
rm %{target}-gcc-%{version}
ln -s gcc %{target}-gcc
ln -s gcc %{target}-gcc-%{version}
%endif
popd
%endif #!mingw

# -------- only limits.h syslimits.h --------
pushd $RPM_BUILD_ROOT%{_gccdir}
mv include-fixed include-fixed.tpm
mkdir include-fixed
cp include-fixed.tpm/README include-fixed/
cp include-fixed.tpm/limits.h include/
cp include-fixed.tpm/syslimits.h include/
rm -r include-fixed.tpm
popd

pushd $RPM_BUILD_ROOT%{_infodir}
gzip -9 -n *.info
popd

%if !%{_CROSS}
if test -f /opt/aldccp/bin/packages_idx; then
  /opt/aldccp/bin/packages_idx -p %{OrgName} -v %{version} $RPM_BUILD_ROOT
fi
%endif

# ------------------- Clean ------------------------------------------
%Clean 

%if %{BUILD_LOCAL_CROSS}
  DE=%{version}-%{release}.%{_build_cpu}.rpm
  DD=%{_rpmdir}/%{_build_cpu}/%{ALD_Ver}%{CrossDestDir}/%{TO_ARCH}%{DestDir}

%else  #%{BUILD_LOCAL_CROSS}
  DE=%{version}-%{release}.%{TO_ARCH}.rpm
  DD=%{_rpmdir}/%{TO_ARCH}/%{ALD_Ver}%{CrossDestDir}%{DestDir}
%endif #!%{BUILD_LOCAL_CROSS}

pushd %{_rpmdir}/%{_target_cpu}
  SE=%{version}-%{release}.%{_target_cpu}.rpm
%if (%{_os} == "mingw") && !%{BUILD_LOCAL_CROSS}
  rm %{name}-$SE
%else  #mingw
  mkdir -p $DD
  mv %{name}-$SE $DD/%{name}-$DE
  mv %{name}-info-$SE $DD/%{name}-info-$DE
  mv %{name}-c++-$SE $DD/%{name}-c++-$DE
%if %{_os} != "mingw"
  mv %{name}-libgcc-$SE $DD/%{name}-libgcc-$DE
  mv %{name}-libstdc++-$SE $DD/%{name}-libstdc++-$DE
  mv %{name}-libstdc++-static-$SE $DD/%{name}-libstdc++-static-$DE
  mv %{name}-libmudflap-$SE $DD/%{name}-libmudflap-$DE
  mv %{name}-libmudflap-static-$SE $DD/%{name}-libmudflap-static-$DE
%endif #!mingw
%endif #!mingw
popd

# --------------- build *.tgz ------------------------
%if %{BUILD_TAR}
pushd $RPM_BUILD_ROOT
%if (%{_os} == "mingw") && !%{BUILD_LOCAL_CROSS}
  TMP_TO=$DD
%else
  TMP_TO=$DD/tar
%endif
  mkdir -p $TMP_TO
  tmp=%{name}-%{version}-%{release}
  mkdir -p $tmp
%if %{BUILD_LOCAL_CROSS}
  cp -r cross $tmp/
%else
  cp -r usr $tmp/
%endif
  tar -cjf $tmp.tar.bz2 $tmp
  mv $tmp.tar.bz2 $TMP_TO
  rm -r $tmp
popd
%endif  #BUILD_TAR

# ------------------- Files ------------------------------------------
%if (%{_os} == "mingw") && !%{BUILD_LOCAL_CROSS}
%Files
%{_prefix}

%else

%Files
%exclude %{_bindir}/*g++
%exclude %{_bindir}/*c++
%{_bindir}

%{_gccdir}/cc1
%{_gccdir}/collect2
%{_gccdir}/*.a
%{_gccdir}/*.o
%{_gccdir}/include
%{_gccdir}/include-fixed
%{_gccdir}/install-tools
%{docdir}
%if !%{BUILD_LOCAL_CROSS}
%exclude %{_mandir}/man1/g++.1.gz
%{_mandir}
%endif
%if %{_os} == "mingw"
%{_libdir}/libgcc_s*
%endif

%files info
%{_infodir}

%files c++
%{_bindir}/*g++
%{_bindir}/*c++
%{_gccdir}/cc1plus
%{_gccdir}/c++
%{_libdir}/libsupc++.a
%if %{_os} == "mingw"
%{_libdir}/libstdc++.a
%else  #mingw
%{_gccdir}/libstdc++.so

%files libgcc
%{_libdir}/libgcc_s*
%{_gccdir}/libgcc_s.so

%files libstdc++
%{_libdir}/libstdc++.so.6*

%files libstdc++-static
%{_libdir}/libstdc++.a

%files libmudflap
%{_libdir}/libmudflap.so.*
%{_libdir}/libmudflapth.so.*
%{_gccdir}/libmudflap.so
%{_gccdir}/libmudflapth.so

%files libmudflap-static
%{_libdir}/libmudflap.a
%{_libdir}/libmudflapth.a
%endif #!mingw
%endif #!mingw
